##################################################################
#                                                                #
#          AMOES v1.01   by   Scott E. Carroll (11/06/02)        #
#                                                                #
# Rev # Date     Modification                                    #
# ----- -------- ----------------------------------------------- #
# v1.00 11/03/02 Original script                                 #
#                                                                #
##################################################################   

use Win32::Console;
$con = Win32::Console->new(STD_OUTPUT_HANDLE);
$con->Title("Additional Manual Observation Entry System");

#system("cls"); 
print "########################################################\n";
print "#                                                      #\n";
print "#            A         T          OOO  B               #\n";
print "#           A A       TTT        O   O B               #\n";
print "#          AAAAA U  U  T     OO  O   O BBB             #\n";
print "#          A   A U  U  T    O  O O   O B  B            #\n";
print "#          A   A  UUU   TTT  OO   OOO  BBB             #\n";
print "#                                                      #\n";
print "#      Additional Manual Observation Entry System      #\n";
print "#                                                      #\n";
print "########################################################\n\n";

open (DATA, ">manual_ob.txt");

cloud:
print "# CLOUD COVER ##########################################\n\n";
@cloud_array = ("Clear","Partly Cloudy","Mostly Cloudy","Cloudy","Obscured","Don't Know","SKIP ELEMENT","EXIT PROGRAM");
for ($x = 0; $x <= 7; $x++) {
  print "  [${x}] ${cloud_array[${x}]}\n";
} 

$cloud_select = &promptUser("\nSelect cloud cover");

if (($cloud_select < 0) || ($cloud_select > 7)) {print "\n\nINVALID ENTRY!!!  Please re-enter data.\n\n"; goto cloud;}
if ($cloud_select == 7) {exit;}
if ($cloud_select == 6) {goto rain;}
print DATA "clouds = ${cloud_array[$cloud_select]}\n";

#############

print "\n\n# PRECIPITATION ########################################\n\n";
$rain_choice = &promptUser("Is there any precipitation occuring (Y/N)? ","N");
if (($rain_choice eq "Y") || ($rain_choice eq "y")) {
  goto rain;
} 
else {
  print DATA "rain = None\n";
  print DATA "snow = None\n";
  print DATA "IceP = None\n";
  print DATA "FrzgRain = None\n";
  goto weather;
}

#############

rain:
print "\n\n# RAIN #################################################\n\n";
@rain_array = ("None","Drizzle","Light","Moderate","Heavy","Light Shower","Moderate Shower","Heavy Shower","SKIP ELEMENT","EXIT PROGRAM");
for ($x = 0; $x <= 9; $x++) {
  print "  [${x}] ${rain_array[${x}]}\n";
} 

$rain_select = &promptUser("\nSelect rain type");

if (($rain_select < 0) || ($rain_select > 8)) {print "\n\nINVALID ENTRY!!!  Please re-enter data.\n\n"; goto rain;}
if ($rain_select == 9) {exit;}
if (($rain_select == 8) ||($rain_select == 0)) {goto frozen;}
print DATA "rain = ${rain_array[$rain_select]}\n";

#############

frozen:
print "\n\n# FROZEN PRECIPITATION #################################\n\n";
$frozen_choice = &promptUser("\nIs there any frozen precipitation occuring (Y/N)? ","N");
if (($frozen_choice eq "Y") || ($frozen_choice eq "y")) {
  goto snow;
} 
else {
  print DATA "snow = None\n";
  print DATA "IceP = None\n";
  print DATA "FrzgRain = None\n";
  goto weather;
}

#############

snow:
print "\n\n# SNOW #################################################\n\n";
@snow_array = ("None","Flurries","Light","Moderate","Heavy","Light Shower","Moderate Shower","Heavy Shower","SKIP ELEMENT","EXIT PROGRAM");
for ($x = 0; $x <= 9; $x++) {
  print "  [${x}] ${snow_array[${x}]}\n";
} 

$snow_select = &promptUser("\nSelect snow type");

if (($snow_select < 0) || ($snow_select > 9)) {print "\n\nINVALID ENTRY!!!  Please re-enter data.\n\n"; goto snow;}
if ($snow_select == 8) {exit;}
if ($snow_select == 7) {goto ice;}
print DATA "snow = ${snow_array[$snow_select]}\n";

#############

ice:
print "\n\n# ICE PELLETS ##########################################\n\n";
@ice_array = ("None","Light","Moderate","Heavy","Light Shower","Moderate Shower","Heavy Shower","SKIP ELEMENT","EXIT PROGRAM");
for ($x = 0; $x <= 8; $x++) {
  print "  [${x}] ${ice_array[${x}]}\n";
} 

$ice_select = &promptUser("\nSelect ice pellet type");

if (($ice_select < 0) || ($ice_select > 8)) {print "\n\nINVALID ENTRY!!!  Please re-enter data.\n\n"; goto ice;}
if ($ice_select == 7) {exit;}
if ($ice_select == 6) {goto zrain;}
print DATA "IceP = ${ice_array[$ice_select]}\n";

#############

zrain:
print "\n\n# FREEZING RAIN ########################################\n\n";
@zrain_array = ("None","Light","Moderate","Heavy","Light Shower","Moderate Shower","Heavy Shower","SKIP ELEMENT","EXIT PROGRAM");
for ($x = 0; $x <= 8; $x++) {
  print "  [${x}] ${zrain_array[${x}]}\n";
} 

$zrain_select = &promptUser("\nSelect freezing rain type");

if (($zrain_select < 0) || ($zrain_select > 8)) {print "\n\nINVALID ENTRY!!!  Please re-enter data.\n\n"; goto zrain;}
if ($zrain_select == 7) {exit;}
if ($zrain_select == 6) {goto weather;}
print DATA "FrzgRain = ${zrain_array[$zrain_select]}\n";

#############

weather:
print "\n\n# WEATHER ##############################################\n\n";
@weather_descriptor = ("None","Thunder/Lightning","Light Fog","Dense Fog","Haze","Smoke","Hail","Blowing Snow","Blowing Dust","EXIT PROGRAM");
@weather_array = ("","thunder","mist","fog","haze","smoke","hail","bsnow","bdust","");
for ($x = 0; $x <= 9; $x++) {
  print "  [${x}] ${weather_descriptor[${x}]}\n";
} 

$weather_select = &promptUser("\nSelect additional weather elements (any w/ no delimiters) ");

if ($weather_select == 9) {exit;}

for ($x = 1; $x <= 8; $x++) {
  if ($weather_select =~ /${x}/) {print DATA "${weather_array[${x}]} = ON\n";}
}

#############

print "\n\n# REMARKS ##############################################\n\n";
$other = &promptUser("Enter additional remarks \(or hit <enter> if none\)\n");

$other = uc($other);
if ($other ne "") {print DATA "other = ${other}\n";}

close (DATA);

#############

sub promptUser {

   #-------------------------------------------------------------------#
   #  two possible input arguments - $promptString, and $defaultValue  #
   #  make the input arguments local variables.                        #
   #-------------------------------------------------------------------#

   local($promptString,$defaultValue) = @_;

   #-------------------------------------------------------------------#
   #  if there is a default value, use the first print statement; if   #
   #  no default is provided, print the second string.                 #
   #-------------------------------------------------------------------#

   if ($defaultValue) {
      print $promptString, "[", $defaultValue, "]: ";
   } else {
      print $promptString, ": ";
   }

   $| = 1;               # force a flush after our print
   $_ = <STDIN>;         # get the input from STDIN (presumably the keyboard)


   #------------------------------------------------------------------#
   # remove the newline character from the end of the input the user  #
   # gave us.                                                         #
   #------------------------------------------------------------------#

   chomp;

   #-----------------------------------------------------------------#
   #  if we had a $default value, and the user gave us input, then   #
   #  return the input; if we had a default, and they gave us no     #
   #  no input, return the $defaultValue.                            #
   #                                                                 # 
   #  if we did not have a default value, then just return whatever  #
   #  the user gave us.  if they just hit the <enter> key,           #
   #  the calling routine will have to deal with that.               #
   #-----------------------------------------------------------------#

   if ("$defaultValue") {
      return $_ ? $_ : $defaultValue;    # return $_ if it has a value
   } else {
      return $_;
   }
}




